
parameter SIZE=8; 
interface test_if (input logic clk);
    logic ld; 
    logic[SIZE-1:0] d_in; 
    logic[SIZE-1:0] r_out, r_out2;
    wire logic[SIZE-1:0] data1, data2, data3; 
    clocking driver_cb @ (posedge clk);
        default input #2 output #3;
        output data1,r_out2; 
        input d_in;
        inout data2;
    endclocking : driver_cb
    modport drvr_if_mp (clocking driver_cb);
endinterface :test_if

class c; 
    virtual interface test_if.drvr_if_mp vif; 
    virtual interface test_if vif_bdl; 
    virtual task t(); 
        @ vif.driver_cb begin 
            vif.driver_cb.r_out2 <= vif.driver_cb.d_in;
            vif.driver_cb.data2 <= vif.driver_cb.d_in; // Why is this OK? 
            /* 1800-2012 14.3 Clocking block declaration
                * A clockvar whose clocking_direction is inout shall behave as if 
                * it were two clockvars, one input and one output, 
                * having the same name and the same clocking_signal. 
                * Reading the value of such an inout clockvar shall be equivalent 
                * to reading the corresponding input clockvar. 
                * Writing to such an inout clockvar shall be equivalent
                *  to writing to the corresponding output clockvar.
            */
            // vif.data3 <= vif.d_in; //illegal
            // line above: Hierarchical name component lookup failed at 'data3
            // vif_bdl.data3 <= 8'b10ZZ_ZZ01; // illegal 
            //  line above: A net is not a legal lvalue in this context 
            //  assign vif_bdl.data3 = 8'b10ZZ_ZZ01; // ILLEGAL 
        end 
    endtask : t

endclass : c

module top2; 
    bit clk;
    test_if m_if(clk);
    initial forever #10 clk=!clk; 
    c c_h=new(); 

    task main(); 
        @ (posedge clk) begin 
            m_if.r_out <= m_if.d_in;
            //m_if.data1 <= m_if.d_in; // A net is not a legal lvalue in this context
            // assign m_if.data1 = m_if.d_in; // ILLEGAL 
        end

    endtask : t

    initial begin 
        c_h.vif=m_if;
        c_h.vif_bdl= m_if;
        c_h.main();
    end

endmodule : top2