
typedef enum 
	{CMD_READ, CMD_WRITE, CMD_NOP, CMD_IDLE, CMD_XMT, CMD_RCV } tx_e; 

class C; 
	// Non integer data types like shortreal, real and realtime are not allowed for random variable declaration.  */
	rand int a;        // int 
	rand bit[7:0] b8;  // array 
	rand tx_e tx;
	rand int unsigned length_dyn, length_aa; 
	
	rand int unsigned mem_dyn[]; 	//	Dynamic arrays  [ ]
	constraint mem_dyn_ln_ct { length_dyn < 4; length_dyn > 0;}  
	// constraint for dynamic array 
	constraint mem_dyn_sz_ct {mem_dyn.size() == length_dyn;}
	
	rand int mem_aa[*];  // same as mem_aa[int];   
	constraint mem_aa_ln_ct { length_aa < 4; length_aa > 0;}   
	constraint mem_aa_sz_ct {mem_aa.size() == length_aa;} 
	rand int q1[$];  
	function void post_randomize();
       $display ("Randomized values: %p", this);
    endfunction : post_randomize
endclass : C

module rando; 
	C c_0; 
	int i;
	initial begin : test
		c_0 = new();
		c_0.mem_aa[1234]=1234;
		c_0.mem_aa[4321]=4321;
		for(i=0; i<=8; i=i+1) begin 
		  c_0.q1.push_front(i);
		  if (!c_0.randomize()) $display("error"); 
		  $display("a=%d, b8=%h, tx=%s", c_0.a, c_0.b8, c_0.tx.name); 
		  $display("c_0.mem_dyn[0]=%d, c_0.mem_aa[1234]=%d, c_0.q1.pop_back()=%d)",  
		            c_0.mem_dyn[0], c_0.mem_aa[1234], c_0.q1.pop_back());
		end
		
	end : test
endmodule : rando


	