//----------------------------------------------------------------------
//   Copyright 2007-2008 SiMantis Inc.
//   All Rights Reserved Worldwide
//
//   Licensed under the Apache License, Version 2.0 (the
//   "License"); you may not use this file except in
//   compliance with the License.  You may obtain a copy of
//   the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in
//   writing, software distributed under the License is
//   distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
//   CONDITIONS OF ANY KIND, either express or implied.  See
//   the License for the specific language governing
//   permissions and limitations under the License.
//----------------------------------------------------------------------

//----------------------------------------------------------------------------
//
// Program 10.6:  examples of "inside" constraint operator
//
//----------------------------------------------------------------------------
import uvm_pkg::*;
`include "uvm_macros.svh"

class rand_c;  // /sv/SiMantis/examples/book_examples/set_member_simple.sv
	rand bit[7:0] a, b, c;
	constraint cst_c1 {a inside {1,3,5,[6:7], [9:2*8],[40:40+14]};} 
endclass

module m; 
	rand_c t; 
	initial begin : init
		t=new();
		for (int i=0; i<10; i++) begin
			#5 if(!t.randomize()) `uvm_error("ATEP", "t.randomize error"); 
			`uvm_info("set_member", $sformatf("t.a=%d, t.b=%d", 
						t.a, t.b), UVM_MEDIUM);	
		end				
	end  :init
endmodule 



