class word_aligned_item;
	rand int unsigned addr;
	constraint word_aligned_addr { addr[1:0] == 2'b00; }
endclass : word_aligned_item



// uvm_users_guide_1.1.pdf page 32 
import uvm_pkg::*;  `include "uvm_macros.svh"
class simple_item extends uvm_sequence_item;
    rand int unsigned addr;
    rand int unsigned data;
    rand int unsigned delay;
    constraint c1 { addr < 16'h2000; }
    constraint c2 { data < 16'h1000; }
// UVM automation macros for general objects
    `uvm_object_utils_begin(simple_item)
    `uvm_object_utils_end
    // Constructor
    function new (string name = "simple_item");
        super.new(name);
    endfunction : new
endclass : simple_item

class word_aligned_item extends simple_item;
    constraint word_aligned_addr { addr[1:0] == 2'b00; }
    `uvm_object_utils(word_aligned_item)
// Constructor
    function new (string name = "word_aligned_item");
        super.new(name);
    endfunction : new
endclass : word_aligned_item

module word_aligned;
    word_aligned_item item_h=new();
    initial begin
        repeat(10) begin 
            if (!item_h.randomize()) `uvm_error("MYERR", "This is a randomize error");
           `uvm_info ("word_aligned test", 
                      $sformatf("addr= %h", item_h.addr), UVM_MEDIUM); 
        end
    end

endmodule

/******************************************************************************
    *
    * REVISION HISTORY:
    *    
*******************************************************************************/
