typedef enum {LOW, MEDIUM, HIGH} AddrType;
class Bus;
	rand bit[7:0] addr; 
	rand AddrType sel;
	constraint addr_range
		{
		(sel == LOW )   -> addr inside { [0 : 1] };
		(sel == MEDIUM) -> addr inside { [2 : 5]};
		(sel == HIGH)   -> addr inside { [6 : 255]};
	}
endclass

class Bus2;
	rand bit[7:0] addr; 
	rand AddrType sel;
	constraint addr_range
		{
		(sel == LOW )   -> addr inside { [0 : 1] };
		(sel == MEDIUM) -> addr inside { [2 : 5]};
		(sel == HIGH)   -> addr inside { [6 : 255]};
	}
	constraint order { solve sel before addr;} 
endclass


class Bus3;
	rand bit[7:0] addr; 
	rand AddrType sel;
	constraint addr_range
		{
		(sel == LOW )   -> addr inside { [0 : 1]  };
		(sel == MEDIUM) -> addr inside { [2 : 5]  };
		(sel == HIGH)   -> addr inside { [6 : 100]};
		(sel == (MEDIUM || HIGH))   -> addr > 80;	
	}
	constraint order { solve sel before addr;} 
endclass




class C;  // v1_implies_v2.sv
	rand bit v1; 
	rand bit v2; 
	constraint cst_v1_0_implies_v2_0 { v1==0 -> v2==0; }   
endclass : C
 
module mc;
	C c=new(); 
	initial begin : init
		for (int i=0; i<30; i++) begin
			if(!c.randomize()) $error; 
			$display("c.v1=%b  c.v2=%d", c.v1, c.v2);
		end
	end  :init

endmodule :mc
