//----------------------------------------------------------------------
//   Copyright 2007-2008 SiMantis Inc.
//   All Rights Reserved Worldwide
//
//   Licensed under the Apache License, Version 2.0 (the
//   "License"); you may not use this file except in
//   compliance with the License.  You may obtain a copy of
//   the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in
//   writing, software distributed under the License is
//   distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
//   CONDITIONS OF ANY KIND, either express or implied.  See
//   the License for the specific language governing
//   permissions and limitations under the License.
//----------------------------------------------------------------------

//----------------------------------------------------------------------------
//
// Program 10.13:  Ordering constraint operator
//
//----------------------------------------------------------------------------

class payload; // /systemverilog/SiMantis_examples/book_examples_0/program_10.13.sv
	rand bit v1;
	rand int unsigned v2;
	constraint c1 {v1 == 1'b0 -> v2 == 0;}
	// constraint c2 {solve v1 before v2;}
endclass

module t; 
	payload p_c=new(); 
	int count0=0; 
	int count1=0;
	initial begin 
		repeat(500) begin 
			if (!p_c.randomize) $display("error"); 
			$display("p_c.v1 %b, p_c.v2 %d", p_c.v1, p_c.v2); 
			if(p_c.v1) count1+=1'b1; 
			else count0+=1'b1;
		end 
		$display("count1=%d, count0 %d", count1, count0); 
	end 
endmodule 


