import uvm_pkg::*;  
`include "uvm_macros.svh"
module simple_ct; // simple_ct.sv
   bit clk, req, ack; 
   string tID="simple";
   ap_req_ack: assert property(@(posedge clk)  
   		$rose(req) |-> ##[1:5] ack) else 
   	    `uvm_info(tID,$sformatf("%m : error in req ack %b %b", req, ack), UVM_MEDIUM)
                      
   initial forever #5 clk=!clk; 
   initial begin 
     repeat(200) begin 
       @(posedge clk);  //with { a < b ; a + b < length ; };
       if (!randomize(req, ack)  with 
           { req dist {1'b1:=1, 1'b0:=3};
       		 ack dist {1'b1:=1, 1'b0:=5};})
       	          `uvm_error("MYERR", "This is a randomize error")
       end 
       $finish; 
    end
endmodule 