package bus_pkg; // txexample.sc
	timeunit 1ns; timeprecision 100ps;
	typedef enum {BS_READ, BS_WRITE, BS_READ_WRITE, BS_IDLE} BS_scen_e;
endpackage : bus_pkg


import bus_pkg::*;
class bus_seq_item;
    rand BS_scen_e kind;
	rand logic[31:0] addr;
	rand logic[31:0] data;
	rand bit x, y;
	rand int delay;
	constraint kind_ct {kind dist 
		{BS_READ:=30, BS_WRITE:=30, BS_READ_WRITE:=30, BS_IDLE:=10 };}
	constraint at_least_1 { delay inside {[1:20]};} 
 
	// 32 bit aligned transfers
	constraint align_32 {addr[1:0] == 0;}
	
	constraint xy_ct { {x, y} dist
		{2'b00:=15, 2'b01:=2, 2'b10:=2, 2'b11:=1};} 
endclass: bus_seq_item
